<script setup>
import { ref, watch } from "vue";
import { closeVault } from "@/api/khronos";
import { useKhronosStore } from "@/store";
import { getVaultHistory, getVaultBalances } from "@/hooks";
import { storeToRefs } from "pinia";

const store = useKhronosStore();

const props = defineProps({
  vault: Object,
  open: String,
});
const { lastRefresh } = storeToRefs(store);

const balances = ref();

const closeVaultReuqest = async () => {
  let trx = await closeVault(store.workspace, props.vault.publicKey);
  console.log(trx);
};

const getVaultTransactions = async () => {
  let transactions = await getVaultHistory(store.workspace, props.vault);
  console.log(transactions);
};

const refreshBalances = async () => {
  if (props.vault.account.isActive) {
    let vaultBalances = await getVaultBalances(store.workspace, props.vault);
    console.log("Balances", vaultBalances);
    balances.value = vaultBalances;
  }
};

watch(lastRefresh, async (prev, curr) => {
  if (props.vault.account.isActive) {
    prev = curr;
    await refreshBalances();
    getVaultTransactions();
  }
});
refreshBalances();
getVaultTransactions();
</script>

<template>
  <div class="row">
    <div class="col">
      {{ String(props.vault.publicKey).substring(0, 2) }}...{{
        String(props.vault.publicKey).substring(
          String(props.vault.publicKey).length - 2
        )
      }}
    </div>
    <div class="col">
      {{ props.vault.account.period }}
    </div>
    <div class="col">
      {{ props.vault.account.percentil }}
    </div>
    <div class="col">
      {{ props.vault.account.initialAmount / 1e6 }}
    </div>
    <div class="col" v-if="balances">
      <div class="row">
        <div class="col">Deposit:<strong>${{ balances.depositAmount.value.uiAmountString }}</strong></div>
        <div class="col">Destination:<strong>{{ balances.destinationAmount.value.uiAmountString }}</strong></div>
      </div>
    </div>
    <div v-if="open" class="col">
      <button :onclick="closeVaultReuqest">Close</button>
    </div>
  </div>
</template>
<!-- 

Account public key (?), Period, Percentil, Initial ammount (vault object) 
Aktuálny zostatok oboch účtov

+ close valut button

-->
